# -*- coding: utf-8 -*-

from enum import Enum, unique
from typing import Final

import cv2

EventFlags = int

EVENT_FLAG_ALTKEY: Final[EventFlags] = cv2.EVENT_FLAG_ALTKEY
EVENT_FLAG_CTRLKEY: Final[EventFlags] = cv2.EVENT_FLAG_CTRLKEY
EVENT_FLAG_LBUTTON: Final[EventFlags] = cv2.EVENT_FLAG_LBUTTON
EVENT_FLAG_MBUTTON: Final[EventFlags] = cv2.EVENT_FLAG_MBUTTON
EVENT_FLAG_RBUTTON: Final[EventFlags] = cv2.EVENT_FLAG_RBUTTON
EVENT_FLAG_SHIFTKEY: Final[EventFlags] = cv2.EVENT_FLAG_SHIFTKEY


@unique
class MouseEvent(Enum):
    LBUTTON_DBLCLK = cv2.EVENT_LBUTTONDBLCLK
    LBUTTON_DOWN = cv2.EVENT_LBUTTONDOWN
    LBUTTON_UP = cv2.EVENT_LBUTTONUP
    MBUTTON_DBLCLK = cv2.EVENT_MBUTTONDBLCLK
    MBUTTON_DOWN = cv2.EVENT_MBUTTONDOWN
    MBUTTON_UP = cv2.EVENT_MBUTTONUP
    MOUSE_HWHEEL = cv2.EVENT_MOUSEHWHEEL
    MOUSE_MOVE = cv2.EVENT_MOUSEMOVE
    MOUSE_WHEEL = cv2.EVENT_MOUSEWHEEL
    RBUTTON_DBLCLK = cv2.EVENT_RBUTTONDBLCLK
    RBUTTON_DOWN = cv2.EVENT_RBUTTONDOWN
    RBUTTON_UP = cv2.EVENT_RBUTTONUP
